var Button = function(id, params) {
	this._id = id;
	this._params = params;
	this._obj = $("#" + id);
	this.init();
};

Button.prototype = {
	init: function() {
		var params = this._params;
		this._text = this._obj.html();
		this._obj.empty();
		this._bg = $("<div class=\"bg\"></div>")
			.appendTo(this._obj);
		this._bd = $("<div class=\"bd\"></div>")
			.appendTo(this._obj);
		var label = createLabelObject(params.icon, params.icon_p, params.gap, this._text);
		this._fg = $("<table class=\"fg\" cellspacing=\"0\" cellpadding=\"0\"><tr><td class=\"labelWrapper\" style=\"white-space:nowrap\">" + label.html() + "</td></tr></table>")
			.appendTo(this._obj);
			
		this._fg.add(this._fg.find("tr")).add(this._fg.find("td")).css("background-image", "url('styles/empty.gif')");
		
		this.setupBehavior(this._obj);
		initReferences(this);

		var me = this;
		setTimeout(function() {
			setState(me, me._params.state, true);
		}, 0);
	},
	updateUI: function(obj) {
		var params = this._params;
		var state = params.state;
		var _bg = obj.children(".bg");
		var _bd = obj.children(".bd");
		var _fg = obj.children(".fg");
		var width = obj.width();
		var height = obj.height();
		
		// background filling
		_bd.css("border-width", "0px").width(width).height(height);
		generateBackgroundAndBorders(state, "", _bg, _bd, params);
		
		// text
		var labelText = _fg.find(".labelWrapper").contents().filter(function() {
			return this.nodeType == 3;
		});
		var curText = (this._text == "" ? " " : this._text);
		if ($('<div>').text(labelText.text()).html() != curText) {
			labelText.replaceWith(curText);
		}

		var preferredWidth = getTextSize(this._text, params["f_n_" + state], params["f_s_" + state]).width;
		if (params.icon_p < 2) {
			preferredWidth += (params.icon ? _fg.find(".icon").width() + params.gap : 0);
		} else {
			preferredWidth = Math.max(preferredWidth, _fg.find(".icon").width());
		}
		var align = params["txt_a_" + state];
		var borderWidth = params["bdw_" + state];
		var margin = Math.min(params.margin, (width - preferredWidth) / 2 - borderWidth);
		_fg.css("padding", "0px").width(width).height(height).css({
			"text-align" : align,
			"padding-left" : margin,
			"padding-right" : margin,
			"cursor": (state == 64 || state == 96) ? "default" : "pointer"
		});
		applyFontParameters(state, "", _fg.find("td"), params);
		// shadow
		applyShadow(obj, _bd, params.shadow);
	},
	setupBehavior : function(obj) {
		var me = this;
		obj.mouseenter(function() {
			setState(me, 16);
		}).mouseleave(function() {
			setState(me, 0);
		}).mousedown(function() {
			setState(me, 32);
		}).mouseup(function() {
			setState(me, 0);
		});
	},
	setCurrentValue : function(text) {
		this._text = text;
		updateElementAndReferences(this);
	},
	getCurrentValue : function() {
		return this._text;
	},
	onStateChanged : function() {
		var params = this._params;
		var state = params.state;
		if (state == 64 || state == 96) {
			this._fg.find(".icon").css("filter", "grayscale(100%)");
		} else {
			this._fg.find(".icon").css("filter", "grayscale(0%)");
		}
	}
};