var Ellipse = function(id, params) {
	this._id = id;
	this._params = params;
	this._obj = $("#" + id);
	this.init();
};

Ellipse.prototype = {
	init : function() {
		initReferences(this);
		var me = this;
		setTimeout(function() {
			updateElementAndReferences(me);
		}, 0);
	},
	updateUI : function(obj) {
		var params = this._params;
		var width = obj.width();
		var height = obj.height();
		var bdWidth = params.bdw_0;
		var halfBdWidth = Math.ceil(bdWidth / 2);
		
		if (params.shadow) {
			obj.css("overflow", "visible");
		}
		
		// create canvas
		var canvas = createCanvas(width, height, params);
		obj.empty().append(canvas);
		$(canvas).css("position", "absolute");
		
		var ctx = getCanvasContext(canvas, params);
		
		drawEllipse(ctx, halfBdWidth, halfBdWidth, width - halfBdWidth * 2, height - halfBdWidth * 2, params);
		
		fillAndStrokeOnCanvas(ctx, width, height, params);
	},
	setBgColor : function(color) {
		var params = this._params;
		params.bg_0 = params.bg_64 = color;
		updateElementAndReferences(this);
	},
	setBgOpacity : function(opacity) {
		var params = this._params;
		params.bgo = opacity/255;
		updateElementAndReferences(this);
	}
};