var GroupFrame = function(id, params) {
	this._id = id;
	this._params = params;
	this._obj = $("#" + id);
	this.init();
};

GroupFrame.prototype = {
	init : function() {
		var params = this._params;
		var me = this;
		var content = this._obj.html();
		this._obj.empty();
		this._bg = $("<div class=\"bg\"></div>")
			.appendTo(this._obj);
		this._bd = $("<div class=\"bd\"></div>")
			.appendTo(this._obj);
		this._fg = $("<div class=\"fg\">" + content + "</div>")
			.appendTo(this._obj);
		
		var margin = params.titleMargin;
		var intersection = params["ints_" + params.state];
		$("<div class=\"title\">" + params.title + "</div>").css({
			"position" : "absolute",
			"padding-left" : margin + "px",
			"padding-top" : (intersection == "outer" ? margin : 0) + "px",
			"padding-right" : margin + "px",
			"padding-bottom" : "0px"
		}).appendTo(this._fg);
		
		initReferences(this);

		setTimeout(function() {
			setState(me, params.state, true);
		}, 0);
	},
	updateUI : function(obj) {
		var params = this._params;
		var state = params.state;
		var _bg = obj.children(".bg");
		var _bd = obj.children(".bd");
		var _fg = obj.children(".fg");
		var width = obj.width();
		var height = obj.height();
		
		var textSize = getTextSize(params.title, params["f_n_" + state], params["f_s_" + state], params["f_b_" + state]);
		var margin = params.titleMargin;
		var offset = params.titleOffset;
		var intersection = params["ints_" + state];
		var offsetY = Math.ceil(intersection == "inner" ? textSize.height + margin 
				: (intersection == "middle" ? textSize.height / 2 : 0));
		
		// background and border
		_bd.add(_bg).css({
			"border-width" : "0px",
			"left" : "0px",
			"top" : offsetY + "px",
			"width" : width + "px",
			"height" : (height - offsetY) + "px"
		});
		generateBackgroundAndBorders(state, "", _bg, _bd, params);
		
		// title
		var align = params["align_" + state];
		var offsetX = align == "left" ? offset : 
			(align == "center" ? (width - textSize.width) / 2 - margin 
					: width - offset - textSize.width - margin * 2);
		var title = _fg.children(".title").css({
			"left" : offsetX + "px",
			"background-color" : (intersection == "middle" ? params["bg_" + state] : "transparent")
		});
		applyFontParameters(state, "", title, params);
		
		// shadow
		applyShadow(obj, _bd, params.shadow);
	}
};