var MenuBar = function(id, params) {
	this._id = id;
	this._params = params;
	this._obj = $("#" + id);
	this.init();
};

MenuBar.prototype = {
	init : function() {
		var params = this._params;
		var content = this._obj.children();
		this._obj.empty();
		this._bg = $("<div class=\"bg\"></div>")
			.appendTo(this._obj);
		this._bd = $("<div class=\"bd\"></div>")
			.appendTo(this._obj);
		this._fg = $("<div class=\"fg\"></div>")
			.appendTo(this._obj);
			
		var gap = params.gap;
		var icons = params.icons;
		var margin = params.txtm;
		var itemWidths = params.widths;
		var menuBar = $("<table style=\"position:absolute;\" cellspacing=\"0\" cellpadding=\"0\"></table>").appendTo(this._fg);
		var menuBarRow = $("<tr class=\"menuBarRow\"></tr>").appendTo(menuBar);
		menuBarRow.append($("<td class=\"menuBarMargin\"></td>").width(margin));
		content.children("li").each(function(index) {
			var label = createLabelObject(icons[index], 0, gap, $(this).html());
			var menuBarItem = $("<td align=\"center\" valign=\"middle\" class=\"menuBarItem\"></td>").css({
				"width" : (itemWidths[index] - margin) + "px",
				"padding-left" : margin + "px",
				"cursor" : "default"
			}).append(label);
			menuBarRow.append(menuBarItem);
		});
		menuBarRow.append($("<td class=\"menuBarPadding\"></td>"));
	
		params.hlIndex = -1;
		
		this.setupBehavior(this._obj);
		initReferences(this);

		var me = this;
		setTimeout(function() {
			setState(me, me._params.state, true);
		}, 0);
	},
	updateUI : function(obj) {
		var me = this;
		var params = this._params;
		var state = params.state;
		var _bg = obj.children(".bg");
		var _bd = obj.children(".bd");
		var _fg = obj.children(".fg");
		var width = obj.width();
		var height = obj.height();
		var margin = params.txtm;
		var horMargin = params["horm_" + state];
		
		_bg.css({
			left : horMargin + "px",
			width : (width - horMargin * 2) + "px"
		});
		
		// menu bar size
		var borderWidth = params["bdw_" + state];
		var menuBarTable = _fg.children("table");
		var rowHeight = height - borderWidth * 2;
		menuBarTable.css({
			left : (borderWidth + horMargin) + "px",
			top : borderWidth + "px",
			width : (width - borderWidth * 2 - horMargin * 2) + "px",
			height : rowHeight + "px"
		});
		var margin = params.txtm;
		var itemWidths = params.widths;
		var totalItemWidth = 0;
		for (var i = 0; i < itemWidths.length; i ++) {
			totalItemWidth += itemWidths[i];
		}
		var paddingWidth = Math.max(0, width - margin - totalItemWidth);
		menuBarTable.find(".menuBarPadding").width(paddingWidth);
		menuBarTable.find("td").height(rowHeight);
		
		// background and border
		_bd.css("border-width", "0px").width(obj.width()).height(obj.height());
		generateBackgroundAndBorders(state, "", _bg, _bd, params);
		
		_bd.css({
			left : horMargin + "px",
			width : (width - borderWidth * 2 - horMargin * 2) + "px"
		});
		
		// prepare rows in bg
		_bg.children("table").remove();
		var bgCells = menuBarTable.clone().css("left", margin + "px").appendTo(_bg).find(".menuBarItem").each(function(index) {
			$(this).css({
				"width" : itemWidths[index] + "px",
				"padding-left" : "0px"
			}).empty();
		});
		
		// prepare rows in bd
		_bd.children("table").remove();
		var bdCells = menuBarTable.clone().css("left", margin + "px").appendTo(_bd).find(".menuBarItem").html("");
		
		// tweak items
		var margin = params.txtm;
		var selIndex = params.selIndex;
		var hlIndex = params.hlIndex;
		var gap = params.gap;
		var icons = params.icons;
		_fg.find(".menuBarItem").each(function(index) {
			var fgCell = $(this);
			var bgCell = $(bgCells.get(index));
			var bdCell = $(bdCells.get(index));
			var tarId = (index == hlIndex || (hlIndex == -1 && index == selIndex)) ? "sel" : "item";
			generateBackgroundAndBorders(state, tarId, bgCell, bdCell, params);
			applyFontParameters(state, tarId, fgCell, params);
		});
		
		// shadow
		applyShadow(obj, _bd, params.shadow);
	},
	setupBehavior : function(obj) {
		var me = this;
		var params = this._params;
		var items = obj.children(".fg").find(".menuBarItem");
		items.click(function() {
			if ((params.state & 64) == 0) {
				me.setSelectedIndex(items.index(this) + 1);
			}
		}).hover(function() {
			if ((params.state & 64) == 0) {
				var curIndex = items.index(this);
				if (params.hlIndex != curIndex) {
					params.hlIndex = curIndex;
					updateElementAndReferences(me);
				}
			}
		}, function() {
			if ((params.state & 64) == 0) {
				params.hlIndex = -1;
				updateElementAndReferences(me);
			}
		});
		obj.mouseleave(function() {
			if ((params.state & 64) == 0) {
				params.selIndex = -1;
				params.hlIndex = -1;
				updateElementAndReferences(me);
			}
		});
	},
	getSelectedIndex : function() {
		return this._params.selIndex + 1;
	},
	setSelectedIndex : function(index) {
		var params = this._params;
		if (params.selIndex != index - 1) {
			params.selIndex = index - 1;
			updateElementAndReferences(this);
			$("#" + this._id).trigger("Selection_Changed");
		}
	}
};