var Polygon = function(id, params) {
	this._id = id;
	this._params = params;
	this._obj = $("#" + id);
	this.init();
};

Polygon.prototype = {
	init: function() {
		initReferences(this);
		var me = this;
		setTimeout(function() {
			updateElementAndReferences(me);
		}, 0);
	},
	updateUI: function(obj) {
		var params = this._params;
		var width = obj.width();
		var height = obj.height();
		var rx = width / params.bounds.width;
		var ry = height / params.bounds.height;
		
		if (params.shadow) {
			obj.css("overflow", "visible");
		}
		
		// create canvas
		var canvas = createCanvas(width, height, params);
		obj.empty().append(canvas);
		$(canvas).css("position", "absolute");
		
		// draw polygon on canvas
		var swing = params.bdt_0 == "swing";
		var ctx = getCanvasContext(canvas, params);
		ctx.beginPath();
		var points = params.points;
		for (var i = 1; i < points.length; i ++) {
			var start = points[i - 1];
			start = { x : start.x * rx, y : start.y * ry };
			var end = points[i];
			end = { x : end.x * rx, y : end.y * ry };
			if (swing) {
				drawSwingLine(ctx, start, end, params.bdsw_int_0, params.bdsw_amp_0, i > 1);
			} else {
				if (i == 1) {
					ctx.moveTo(start.x, start.y);
				}
				ctx.lineTo(end.x, end.y);
			}
		}
		if (params.closed == true) {
			ctx.closePath();
		}
		fillAndStrokeOnCanvas(ctx, width, height, params);
	},
	setBgColor : function(color) {
		var params = this._params;
		params.bg_0 = params.bg_64 = color;
		updateElementAndReferences(this);
	},
	setBgOpacity : function(opacity) {
		var params = this._params;
		params.bgo = opacity / 255;
		updateElementAndReferences(this);
	}
};